'
' Event log collection scriptiBinary data collection versionj
' 
' Creator : E.Noguchi (2007/06/28)
'
Option Explicit

Const ForWriting = 2
Const SEPARATER = ","
Const CONVERT_TO_LOCAL_TIME = True

Dim fso
Dim strComputer
Dim objWMIService

Dim Arg
Dim LogType
Dim CutSize
Dim OutFile
Dim Range
Dim i

Set fso = CreateObject("Scripting.FileSystemObject")
strComputer = "." 
Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

'----------------------------------------
' Get arguments
LogType = "Application"
CutSize = Null
OutFile = Null
Range   = Null
For i = 0 To WScript.Arguments.Count - 1
	Arg = WScript.Arguments(i)
	If UCase(Left(Arg,6)) = "/TYPE:" Then
		LogType = Mid(Arg,7)
	ElseIf UCase(Left(Arg,5)) = "/OUT:" Then
		OutFile = Mid(Arg,6)
	ElseIf UCase(Left(Arg,6)) = "/SIZE:" Then
		CutSize = CLng(Mid(Arg,7))
	ElseIf UCase(Left(Arg,7)) = "/RANGE:" Then
		Range   = CInt(Mid(Arg,8))
	End If
Next

'----------------------------------------
' Collection start
PrintEventLog LogType, OutFile, CutSize, Range

' Exit from script
WScript.Quit 0

'****************************************
'* Tu[`                 *
'****************************************
Sub PrintEventLog(LogType, OutFileName, CutSize, Range)
	Dim dtmStartDate
	Dim OutFile
	Dim OutStream
	Dim colEvents
	Dim objEvent
	Dim strLine
	
	' o͐ݒ
	OutFile   = Null
	OutStream = Null
	If Not IsNull(OutFileName) then
		fso.CreateTextFile OutFileName, True
		Set OutFile   = fso.GetFile(OutFileName)
		Set OutStream = OutFile.OpenAsTextStream(ForWriting)
	End If
	
	' ͈͐ݒ
	dtmStartDate = Null
	If Not IsNull(Range) Then
		Set dtmStartDate = CreateObject("WbemScripting.SWbemDateTime") 
		dtmStartDate.SetVarDate CDate(Now) - Range, CONVERT_TO_LOCAL_TIME
	End If
	
	Set colEvents = objWMIService.ExecQuery("SELECT * FROM Win32_NTLogEvent WHERE LogFile = '" & LogType & "'") 
	
	For Each objEvent In colEvents
		' wOŏI
		If Not IsNull(dtmStartDate) Then
			If objEvent.TimeWritten < dtmStartDate Then Exit For
		End If
		
		' PCxgҏW
		strLine = Left(objEvent.TimeWritten, 4) & "/" & Mid(objEvent.TimeWritten, 5, 2) & "/" & Mid(objEvent.TimeWritten, 7, 2)
		strLine = strLine & SEPARATER & Mid(objEvent.TimeWritten, 9, 2) & ":" & Mid(objEvent.TimeWritten, 11, 2) & ":" & Mid(objEvent.TimeWritten, 13, 2)
		strLine = strLine & SEPARATER & objEvent.SourceName
		strLine = strLine & SEPARATER & objEvent.Type
		strLine = strLine & SEPARATER & CategoryToString(objEvent.Category)
		strLine = strLine & SEPARATER & objEvent.EventCode
		strLine = strLine & SEPARATER & SpaceToNA(objEvent.User)
		strLine = strLine & SEPARATER & objEvent.ComputerName
		strLine = strLine & SEPARATER & objEvent.Message
		If Not IsNull(objEvent.Data) then
			strLine = strLine & vbCrLf & FormatDump(objEvent.Data)
		End If
		
		' TCY𒴂I
		If Not IsNull(OutFile) And Not IsNull(CutSize) then
			If OutFile.Size > CutSize Then Exit For
		End If
		
		' ҏWʏo
		If IsNull(OutStream) then
			Wscript.Echo strLine
		Else
			OutStream.WriteLine strLine
		End If
	Next
End Sub

Function SpaceToNA(src)
	SpaceToNA = "" & src
	If SpaceToNA = "" Then
		SpaceToNA = "N/A"
	End If
End Function
Function CategoryToString(idCategory)
	CategoryToString = idCategory
	If idCategory = 0 Then
		CategoryToString = "Ȃ"
	End If
End Function

Function WMIDateStringToDate(dtmEventDate)
	WMIDateStringToDate = CDate(Mid(dtmEventDate, 5, 2) & "/" & Mid(dtmEventDate, 7, 2) & "/" & Left(dtmEventDate, 4) & " " & _
		Mid (dtmEventDate, 9, 2) & ":" & Mid(dtmEventDate, 11, 2) & ":" & Mid(dtmEventDate, 13, 2))
End Function

Function FormatDump(arraydata)
	Dim HexLine
	Dim StrLine
	Dim count
	Dim data
	Dim Addr
	
	HexLine = ""
	StrLine = ""
	count = 0
	For Each data In arraydata
		HexLine = HexLine & HexFix(data,2)
		If data < 32 Or data >= 128Then
			StrLine = StrLine & "."
		Else
			StrLine = StrLine & Chr(data)
		End If
		If count mod  4 =  3 Then HexLine = HexLine & " "
		If count mod 16 =  0 Then Addr = HexFix(count,4)
		If count mod 16 = 15 Then
			FormatDump = FormatDump & Addr & ": " & HexLine & " " & StrLine & vbCrLf
			HexLine = ""
			StrLine = ""
		End If
		count = count + 1
	Next
	If HexLine <> "" Then
		Space(36 - Len(HexLine))
		FormatDump = FormatDump & Addr & ": " & HexLine & Space(36 - Len(HexLine)) & " " & StrLine & vbCrLf
	End If
End Function

Function TrimCRLF(str)
	Do While Left(str,2) = vbCrLf
		str = Mid(str,3)
	Loop
	Do While Right(str,2) = vbCrLf
		str = Left(str, Len(str)-2)
	Loop
	TrimCRLF = str
End Function

Function HexFix(num,wid)
	HexFix = Hex(num)
	HexFix = String(wid - Len(HexFix),"0") & HexFix
End Function
