Option Explicit

Function NewRegExp(patrn)
	Set NewRegExp = New RegExp
	NewRegExp.Pattern    = patrn
	NewRegExp.IgnoreCase = True
	NewRegExp.Global     = False
End Function

Function ExecRegExp(regEx, strng)
	Dim Match, Matches
	Set Matches = regEx.Execute(strng)
	For Each Match in Matches
		ExecRegExp = True
		Exit Function
	Next
	ExecRegExp = False
End Function

Dim objWMIService
Dim strComputer
Dim colItems, objItem
Dim VendorID, DeviceID
Dim regVendorID, regDeviceID, regSubVenID, regSubDevID
Dim SubSystem, SubVenID, SubDevID

Set regVendorID = Nothing
Set regDeviceID = Nothing
Set regSubVenID = Nothing
Set regSubDevID = Nothing

If WScript.Arguments.length > 0 Then
	Set regVendorID = NewRegExp(WScript.Arguments(0))
	Set regDeviceID = NewRegExp(WScript.Arguments(1))
	If WScript.Arguments.length = 4 Then
		Set regSubVenID = NewRegExp(WScript.Arguments(2))
		Set regSubDevID = NewRegExp(WScript.Arguments(3))
	End If
End If

strComputer = "." 
Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")

Set colItems = objWMIService.ExecQuery("Select * from Win32_PnPEntity") 

For Each objItem in colItems 
	If Left(objItem.DeviceID,4) = "PCI\" Then
		If regVendorID Is Nothing Then
			WScript.Echo objItem.DeviceID
			WScript.Echo "    " & objItem.Name
		Else
			VendorID = Mid(objItem.DeviceID,InStr(objItem.DeviceID,"VEN_")+4,4)
			DeviceID = Mid(objItem.DeviceID,InStr(objItem.DeviceID,"DEV_")+4,4)
			If ExecRegExp(regVendorID, VendorID) And ExecRegExp(regDeviceID, DeviceID) Then
				If regSubVenID Is Nothing Then
					WScript.Quit 0
				End If
				SubSystem = Mid(objItem.DeviceID,InStr(objItem.DeviceID,"SUBSYS_")+7,8)
				SubVenID = Mid(SubSystem,5,4)
				SubDevID = Mid(SubSystem,1,4)
				If ExecRegExp(regSubVenID, SubVenID) And ExecRegExp(regSubDevID, SubDevID) Then
					WScript.Quit 0
				End If
			End If
		End If
	End If
Next

WScript.Quit 1
